# camOS
- 队伍名：随便取名不对
- 学校：哈尔滨工业大学（深圳）


![logo](./docs/images/logo.png)


# 项目概况
本项目是以 2022 年全国大学生系统能力大赛-操作系统设计赛为驱动，自主 设计、研发的通用操作系统内核。目前项目主要面向 RISCV 平台架构的 SiFive Unmatched 开发板，现已成功通过大赛的所有初赛测试用例，通过一部分决赛第一阶段测试用例。下面是大赛在线评测的评分表。
![scores](./docs/images/scores.png)

![scores](./docs/images/finals1.png)

![scores](./docs/images/finals2.png)

# 项目结构介绍
- bootloader/ 存储bootloader二进制文件
- crates/ 存储外部库源代码
- docs/ 存储项目部分文档
- src/ 项目源代码目录
- userenv/ 用户态应用程序开发环境
- 项目文档.pdf 项目总体文档

# 初赛已完成系统调用
- [x] getpid
- [x] getppid
- [x] getcwd
- [x] pipe
- [x] dup
- [x] dup3
- [x] mkdirat
- [x] linkat
- [x] unlinkat
- [x] mount
- [x] umount
- [x] chdir
- [x] openat
- [x] close
- [x] getdents64
- [x] lseek
- [x] write
- [x] fstat
- [x] read
- [x] exit
- [x] yield
- [x] wait4
- [x] sbrk
- [x] brk
- [x] clone
- [x] exec
- [x] mmap
- [x] munmap
- [x] times
- [x] uname
- [x] get_time_of_day
- [x] nanosleep

# 总结与展望
目前的camOS操作系统内核已经具备基本成型的框架，支持虚拟内存、进程管理、时钟中断、虚拟文件系统接口、FAT32文件系统等等功能，能够支持运行简单的用户态程序。目前能够比较轻松地在camOS上继续迭代开发支持操作系统的更多特性，比如Copy on Write，或者实现更多系统调用以支持部分Linux应用程序的运行，例如busybox等。当然，camOS最终希望的是提供一个简化的操作系统内核，具备良好的抽象能力，方便对其进行进一步的改进与开发以适应不同的嵌入式设备的要求，满足嵌入式设备应用开发的要求，推进中国物联网的发展。
