日期: 2022-05-06
错误描述: 线上提交的时候，在运行某个不特定用户态测试程序时，后续没有日志输出，亦无panic信息.

补丁#1: 
  * 文件: src/spi_sd/mod.rs
  * 分析: 由于之前改变了时钟频率，怀疑是时钟频率过高问题。
  * 内容: 通过修改set_clk_rate函数降低SD卡时钟频率。

补丁#2:
  * 文件: src/spi_sd/mod.rs
  * 分析: 经过测试，发现写入时会在块开头多写入一个0。可能是write_sector函数在块写入过程中多写了一个0。
  在写入每个块之前，都需要写入块开始标识符0xFE，随后开始写入块内容。
  在K210的SD卡实现中，在写入0xFE之后，又紧接着写了一个0。这事实上是不需要的，且导致了SD卡错认为块首第一个字符为0x00。
  * 内容: 删除写入块时块开始标识符0xFE后的0x00。

补丁#2:
  * 文件: src/spi_sd/mod.rs
  * 分析: 在qemu上进行测试，会出现read block invalid的panic，这次读取是在一次写入之后的。
  通过qemu插桩发现，qemu并没有正确识别写入指令，将写入的数据当作了指令处理。
  通过重新研究K210的SD卡实现，发现其在发送0xFE之前，先发送了8个时钟0xFF，故据此修改。
  * 内容: 在写入时，发送块开始标识符0xFE之前先发送一个时钟0xFF。