mod lru;

pub trait BlockIOWrapper {
    fn read_block(&self, blk: usize, buf: &mut[u8]);
    fn write_block(&self, blk: usize, buf: &[u8]);
}

pub trait BlockCache {
    fn read_block(&self, blk: usize, buf: &mut[u8]);
    fn write_block(&self, blk: usize, buf: &[u8]);
    fn sync(&self);
}

pub use lru::LRUCache;
