#![allow(unused)]
use alloc::boxed::Box;
use alloc::collections::BTreeMap;
use spin::Lazy;

pub type INT = i32;

pub static CONTEST_TEST: &'static [u8] = include_bytes!("bin/contest_test");
pub static SHELL: &'static [u8] = include_bytes!("bin/shell");
pub static RUNTEST: &'static [u8] = include_bytes!("bin/runtest.exe");
pub static OSCOMP: &'static [u8] = include_bytes!("bin/oscomp");
pub static ENTRY_STATIC: &'static [u8] = include_bytes!("bin/entry-static.exe");
pub static RUNBUSYBOX: &'static [u8] = include_bytes!("bin/runbusybox");

/*
#[cfg(feature = "memfs")]
mod binary;
*/

#[cfg(feature = "memfs")]
pub static APPS: Lazy<BTreeMap<&'static str, Box<&'static [u8]>>> = Lazy::new(|| {
    // use binary::*;
    let mut map = BTreeMap::new();
    /*
    map.insert("brk", Box::new(*BRK));
    map.insert("close", Box::new(*CLOSE));
    map.insert("execve", Box::new(*EXECVE));
    map.insert("fstat", Box::new(*FSTAT));
    map.insert("getpid", Box::new(*GETPID));
    map.insert("mkdir_", Box::new(*MKDIR_));
    map.insert("mount", Box::new(*MOUNT));
    map.insert("openat", Box::new(*OPENAT));
    map.insert("sleep", Box::new(*SLEEP));
    map.insert("test_echo", Box::new(*TEST_ECHO));      
    map.insert("text.txt", Box::new(*TEXT_TXT));
    map.insert("uname", Box::new(*UNAME));
    map.insert("waitpid", Box::new(*WAITPID));
    map.insert("chdir", Box::new(*CHDIR));  
    map.insert("dup", Box::new(*DUP));    
    map.insert("exit", Box::new(*EXIT));
    map.insert("getcwd", Box::new(*GETCWD));
    map.insert("getppid", Box::new(*GETPPID));
    map.insert("mmap", Box::new(*MMAP));
    map.insert("munmap", Box::new(*MUNMAP));
    map.insert("pipe", Box::new(*PIPE));
    map.insert("times", Box::new(*TIMES));
    map.insert("unlink", Box::new(*UNLINK));
    map.insert("write", Box::new(*WRITE));
    map.insert("clone", Box::new(*CLONE));
    map.insert("dup2", Box::new(*DUP2));
    map.insert("fork", Box::new(*FORK));
    map.insert("getdents", Box::new(*GETDENTS));
    map.insert("gettimeofday", Box::new(*GETTIMEOFDAY));
    map.insert("open", Box::new(*OPEN));
    map.insert("read", Box::new(*READ));
    map.insert("umount", Box::new(*UMOUNT));
    map.insert("wait", Box::new(*WAIT));
    map.insert("yield", Box::new(*YIELD));
    */
    map.insert("runtest.exe", Box::new(RUNTEST));
    map.insert("oscomp", Box::new(OSCOMP));
    map.insert("contest_test", Box::new(CONTEST_TEST));
    map.insert("entry-static.exe", Box::new(ENTRY_STATIC));
    map.insert("busybox", Box::new(BUSYBOX));
    map
});
