mod dentry;
mod file;
#[cfg(feature = "memfs")]
mod memfs;
mod path;
mod pipe;
pub mod kstat;
pub mod devfs;

pub use dentry::*;
pub use file::*;
#[cfg(feature = "memfs")]
pub use memfs::*;
pub use path::*;
pub use pipe::*;
use spin::Lazy;

#[cfg(feature = "fat32fs")]
pub static ROOT: Lazy<Inode> = Lazy::new(|| { crate::fat32_wrapper::FAT32ROOT.clone() });

#[cfg(feature = "memfs")]
pub static ROOT: Lazy<Inode> = Lazy::new(|| { crate::vfs::memfs::MEMFSROOT.clone() });
