
#![no_std]
#![no_main]

mod syscall;
mod runtime;
mod console;

use syscall::*;
fn run_busybox(_argv: &[&str]) {
    // println!("Runing {}", name);
    let fork_ret = syscall_fork();
    if fork_ret > 0 {
        let mut wstatus = 0;
        let mut rusage = 0;
        syscall_wait4(-1, &mut wstatus, 0, &mut rusage);
    } else if fork_ret == 0 {
        let mut argv: [usize; 10] = [0; 10];
        for i in 0.._argv.len() {
            argv[i] = _argv[i].as_ptr() as usize;
        }
        let envp: [usize; 1] = [0];
        let mut n: [u8; 512] = [0; 512];
        syscall_execve("/busybox\0", &argv, &envp);
        syscall_exit(-1);
    } else {
        println!("Run: fork error");
    }
}

fn main() {
    println!("Start to run busybox");
    run_busybox(&["";0]);
    println!("End to run busybox");
}
